#ifndef MyFunctionMap_H
#define MyFunctionMap_H

#include <string>
#include <map>
#include <TF1.h>

class MyFunctionMap: public TObject {
public:
   MyFunctionMap() = default;

   template<typename ... Args>
     void set(const std::string &name, Args&& ... args) {
       funcs[name] = TF1(name.c_str(), std::forward<Args>(args)...);
     }
   const TF1& get(const std::string &name) { return funcs.at(name); }
private:
   std::map<std::string, TF1> funcs;

   ClassDef(MyFunctionMap, 1);
};

#endif
